/* rawnetcc /tmp/test files/eth_base/eth.c files/arp/arp.c files/ipv4_base/ipv4.c files/ipv4_config/ipv4_config.c files/ipv4_route_table/ipv4_route_table.c files/udp/udp.c files/rip/rip.c */

#include "rip.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <netinet/in.h>
#include <timerms.h>

void rip_print_packet (rip_packet_t *response, int length) {

	if(response->command == RIP_COMMAND_REQUEST){
		printf("Tipo de paquete RIP: Request\n");
	} else if (response->command == RIP_COMMAND_RESPONSE) {
		printf("Tipo de paquete RIP: Response\n");
	} else {
		printf("Tipo de paquete RIP: %d\n", response->command);
	}
	printf("Version: %d\n", response->version);
	printf("Entries\n\n");
	int i;

	for (i = 0; i < length; i++){
		printf("Entry number %d\n", i);
		printf("Address family: %d\n", ntohs(response->entries[i].addr_family_id));
		printf("Route_tag: %d\n", ntohs(response->entries[i].route_tag));
		char ipv4_addr_read[IPv4_STR_MAX_LENGTH];
    	ipv4_addr_str(response->entries[i].ipv4_addr, ipv4_addr_read);
    	printf("IP address: %s\n", ipv4_addr_read);
    	ipv4_addr_str(response->entries[i].subnet_mask, ipv4_addr_read);
    	printf("Subnet mask: %s\n", ipv4_addr_read);
    	ipv4_addr_str(response->entries[i].next_hop, ipv4_addr_read);
    	printf("Next hop: %s\n", ipv4_addr_read);
    	printf("Metric: %ld\n\n", (long int) ntohl(response->entries[i].metric));
	}
}

int rip_len2entries(int len){
	return (len - RIP_HEADER_LENGTH)/RIP_ENTRY_LENGTH;
}
int rip_entries2len(int entries){
	return entries * RIP_ENTRY_LENGTH + RIP_HEADER_LENGTH;
}
