#ifndef _UDP_H
#define _UDP_H

#include "../ipv4_base/ipv4.h"
#include <stdint.h>

#define UDP_HEADER_LENGTH 8 /* Tamaño de la cabecera UDP. */
#define MTU_UDP 1472 /* IP_MTU - UDP_HEADER_LENGTH */

/* Los puertos 49.152 a 65.535 son puertos dinámicos y son utilizados
como puertos temporales, sobre todo por los clientes al comunicarse con los servidores. */
#define UDP_MIN_PORT 49152
#define UDP_MAX_PORT 65536

typedef struct udp_datagram udp_datagram_t;
typedef struct phd_layer phd_layer_t;
typedef struct udp_layer udp_layer_t;

udp_layer_t * udp_open(char * config_file, char* route_table_file, uint16_t port);

int udp_close(udp_layer_t * udp_layer);

int udp_send(udp_layer_t * udp_layer, ipv4_addr_t ip_dst, uint16_t port_dst, unsigned char* data, int length);

int udp_receive(udp_layer_t * udp_layer, ipv4_addr_t ipv4_addr_src, uint16_t * port_src, unsigned char buffer[], int buf_len, long int timeout);

char * udp_getiface_name (udp_layer_t * udp_layer);

#endif
